<?php

/**
 * Helper function to fix workflow history for migrated surveys.
 *
 * @param $type
 *   Entityform type.
 */
function fix_migrated_workflow_history($type) {
  // Build query to retrieve migrated surveys info.
  $query = get_migrated_entityforms_query($type);

  $results = db_query($query)->fetchAll();

  $db = get_legacy_conection();

  foreach ($results as $result){
    // Find old transitions.
    $old_transitions_query = $db->query("SELECT * FROM workflow_node_history
                                        WHERE nid = :oldid
                                        AND entity_type = 'entityform'
                                        ORDER BY stamp ASC", [':oldid' => $result->sourceid1]);

    $old_transitions = $old_transitions_query->fetchAll();

    if (!empty($old_transitions)) {
      // Update every existing transition with the original data.
      foreach ($old_transitions as $transition) {
        // Find correct user.
        $user_query = db_select('migrate_map_users', 'u');
        $user_query->addField('u', 'destid1');
        $user_query->condition('sourceid1', $transition->uid);

        $user = $user_query->execute()->fetchField();

        // If a migrated user is found, change the transition uid value.
        if (!empty($user)) {
          $transition->uid = $user;
        }

        // Update existing transitions.
        $update = db_update('workflow_node_history')
          ->fields([
            'stamp' => $transition->stamp,
            'uid' => $transition->uid,
            'comment' => $transition->comment,
          ])
          ->condition('old_sid', $transition->old_sid)
          ->condition('sid', $transition->sid)
          ->condition('nid', $result->entityform_id)
          ->condition('entity_type', 'entityform')
          ->execute();
      }

      // Update transitions created by migration.
      $first_transition = $old_transitions[0];

      $update = db_update('workflow_node_history')
        ->fields([
          'stamp' => $first_transition->stamp,
          'uid' => $first_transition->uid,
          'comment' => "These are the first transitions generated by migration, but users and dates are the real ones.",
        ])
        ->condition('nid', $result->entityform_id)
        ->condition('entity_type', 'entityform')
        ->condition('uid', 1)
        ->execute();
    }
  }
}

/**
 * Reassign images of migrated entityforms.
 *
 * @param $field
 *   Image field to fix.
 * @param $entity_info
 *   Entity info, including source ID.
 *
 * @return int
 * @throws \EntityMetadataWrapperException
 */
function fix_migrated_forms_files($field, $entity_info) {
  $fixed = 0;
  // Get original image from legacy database.
  $old_file = get_image_file_data($field, $entity_info->sourceid1);
  // Get current image from current database.
  $new_file = get_image_file_data($field, $entity_info->entityform_id, FALSE);

  if (!empty($old_file) && ($old_file[0]->filename != $new_file[0]->filename || $old_file[0]->uri != $new_file[0]->uri)) {
    $old_file = reset($old_file);

    // Fix assigned file.
    // Try to load existing image with the same uri.
    $file = file_load_multiple([], ['uri' => $old_file->uri]);

    // If the file exists, use that entity.
    if (!empty($file)) {
      $file = reset($file);
    }
    else {
      // Build the legacy file path.
      $file_realpath = drupal_realpath($old_file->uri);
      $file_realpath = explode('/', $file_realpath);
      $file_realname = array_pop($file_realpath);
      $file_realpath[] = LEGACY_FILES;
      $file_realpath[] = $file_realname;
      $file_realpath = implode('/', $file_realpath);

      // Get image content and create file entity.
      $file_tmp = file_get_contents($file_realpath);
      $file = file_save_data($file_tmp, $old_file->uri, FILE_EXISTS_RENAME);
    }

    // Update entity with correct image.
    $wrapper = entity_metadata_wrapper('entityform', $entity_info->entityform_id);
    $wrapper->$field->file->set($file);
    $wrapper->save();

    $fixed = 1;
  }

  return $fixed;
}

/**
 * Get legacy database contection.
 *
 * @return \DatabaseConnection
 */
function get_legacy_conection() {
  return Database::getConnection('default', 'legacy');
}

/**
 * Get query to retrieve migrated forms info with its source and new ID.
 *
 * @param $type
 *   Entityform type.
 *
 * @return string
 *   Query to retrieve the info.
 */
function get_migrated_entityforms_query($type, $limit = NULL, $offset = NULL, $count = FALSE) {
  switch ($type) {
    case 'system':
      $table = "migrate_map_system";
      break;
    case 'community':
      $table = "migrate_map_community";
      break;
    case 'pat':
      $table = "migrate_map_pat";
      break;
    case 'serviceprovider':
      $table = "migrate_map_serviceprovider";
      break;
    default:
      return "";
  }

  if (!$count) {
    $query = "SELECT eform.type, eform.entityform_id, old.sourceid1 FROM entityform eform
            INNER JOIN {$table} old ON old.destid1 = eform.entityform_id";
  }
  else {
    $query = "SELECT count(*) FROM entityform eform
            INNER JOIN {$table} old ON old.destid1 = eform.entityform_id";
  }

  if (!empty($limit)) {
    $query .= "\nLIMIT {$limit}";
  }

  if (!empty($offset)) {
    $query .= "\nOFFSET {$offset}";
  }

  return $query;
}

/**
 * Get file data form legacy database.
 *
 * @param $field_name
 *   File field name.
 * @param $entity_id
 *   Entityform ID.
 *
 * @return mixed
 */
function get_image_file_data($field_name, $entity_id, $legacy = TRUE) {
  $query = "SELECT img.entity_id, img.{$field_name}_fid, file.* FROM field_data_{$field_name} img
            INNER JOIN file_managed file ON file.fid = img.{$field_name}_fid
            WHERE img.entity_type = 'entityform'
            AND img.entity_id = :entityid";

  if ($legacy) {
    $db = get_legacy_conection();
  }
  else {
    $db = Database::getConnection();
  }

  return $db->query($query, [':entityid' => $entity_id])->fetchAll();
}
